/*-
 * ~~~~~~licensing~~~~~~
 * events-api
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.system.core.events.jpa;

import org.hibernate.Session;
import ru.entaxy.esb.system.core.events.common.SubscriptionType;
import ru.entaxy.esb.system.core.events.jpa.entity.EventTopic;
import ru.entaxy.esb.system.core.events.jpa.entity.SystemSubscription;
import ru.entaxy.esb.system.jpa.entity.System;

import java.util.List;

public interface SystemSubscriptionService {

    List<SystemSubscription> list();

    List<SystemSubscription> listByDeleted(boolean deleted);

    SystemSubscription get(long id);

    List<SystemSubscription> getBySystem(long systemRegistryId);

    SystemSubscription getBySystemAndTopic(long systemRegistryId, long eventTopicId);

    List<SystemSubscription> getByTopic(long eventTopicId);

    List<SystemSubscription> getByTopic(Session s, long eventTopicId);

    List<SystemSubscription> getByTopicAndType(long eventTopicId, SubscriptionType type);

    List<SystemSubscription> getByType(SubscriptionType type);

    SystemSubscription add(SystemSubscription systemSubscriptionRegistry) throws Exception;

    SystemSubscription add(System system, EventTopic eventTopic, SubscriptionType type) throws Exception;

    SystemSubscription update(SystemSubscription systemSubscriptionRegistry);

    void remove(long id);

    void removeByTopic(long eventTopicId);

    void removeByTopic(Session s, long eventTopicId);

    void markAsDeleted(long id, boolean deleted);

    void markAsDeletedByTopic(long eventTopicId, boolean deleted);

    void markAsDeletedByTopic(Session s, long eventTopicId, boolean deleted);

}
